// ------------------------------------------------------------------
// exemple-pthread-attr-setaffinity.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2018 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#define _GNU_SOURCE
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sched.h>

void * fonction(void * arg)
{
	long num = (long) arg;
	while (1) {
		fprintf(stdout, "[Thread %ld] I'm on CPU #%d\n", num, sched_getcpu());
		sleep(5);
	}
}


int main(void)
{
	cpu_set_t       cpuset;
	pthread_t       thr;
	pthread_attr_t  attr;
	long num;

	num = 0;
	while (1) {
		// Initialiser avec les attributs par defaut
		pthread_attr_init(& attr);
		// Preparer le cpuset
		CPU_ZERO(&(cpuset));
		CPU_SET(num, &(cpuset));
		// Fixer l'affinite
		pthread_attr_setaffinity_np(& attr,
		                            sizeof(cpu_set_t),
		                            & cpuset);
		// Lancer le thread
		if (pthread_create(& thr, & attr, fonction, (void *) num) != 0)
			break; 
		num ++;
	}

	pthread_exit(NULL);
}

