// ------------------------------------------------------------------
// exemple-sched-getcpu.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2018 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#define _GNU_SOURCE  // sched_getcpu() est une extension GNU
#include <sched.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

int main(void)
{
	int my_cpu;
	int prev_cpu = -1;
	time_t now;
	struct tm *tm_now;

	while (1) {
		my_cpu=sched_getcpu();
		if (my_cpu == -1) {
			perror("sched_getcpu");
			exit(EXIT_FAILURE);
		}
		if (prev_cpu == -1)
			prev_cpu = my_cpu;
		if (my_cpu != prev_cpu) {
			now = time(NULL);
			tm_now = localtime(& now);
			fprintf(stdout, "%02d:%02d:%02d migration %d -> %d\n",
			         tm_now->tm_hour, tm_now->tm_min, tm_now->tm_sec,
			         prev_cpu, my_cpu);
			prev_cpu = my_cpu;
		}
	}
	return EXIT_SUCCESS;
}
