// ------------------------------------------------------------------
// exemple-threads.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2018 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void * factorial(void * arg)
{
	int i;
	long n = (long) arg;
	long result = 1;

	for (i = 2; i <= n; i ++) {
		result = result * i;
		fprintf(stderr, "%ld!: computing...\n", n);
		sleep(1);
	}
	return (void *) result;
}


int main(int argc, char * argv[])
{
	pthread_t * threads = NULL;
	void * ret;
	int i;
	long n;

	// Verification des arguments
	if (argc < 2) {
		fprintf(stderr, "usage: %s values...\n", argv[0]);
		exit(EXIT_FAILURE);
	}
	// Allocation d'un tableau d'identifiants 
	threads = calloc(argc-1, sizeof(pthread_t));
	if (threads == NULL) {
		perror("calloc");
		exit(EXIT_FAILURE);
	}
	fprintf(stderr, "main(): starting threads\n");
	for (i = 1; i < argc; i ++) {
		// Recuperation de l'argument numerique
		if (sscanf(argv[i], "%ld", & n) != 1) {
			fprintf(stderr, "%s: invalid\n", argv[i]);
			exit(EXIT_FAILURE);
		}
		// Lancement du thread
		if (pthread_create(& (threads[i-1]), NULL, factorial, (void *) n) != 0) {
			fprintf(stderr, "Unable to start thread #%d\n", i);
			exit(EXIT_FAILURE);
		}
	}
	fprintf(stderr, "main(): threads started\n");
	for (i = 1; i < argc; i ++) {
		// Attente du thread
		pthread_join (threads[i-1], & ret);
		fprintf (stderr, "main(): %s! = %ld\n", argv[i], (long) ret);
	}
	fprintf(stderr, "main(): threads terminated\n");
	free(threads);
	return EXIT_SUCCESS;
}

