// ---------------------------------------------------------------------
// exemple-nice-threads.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2015 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>


void * thread_function (void * arg)
{
	long nice_value = (long) arg;
	time_t start;
	long nb_loops = 0;

	nice(nice_value);
	start = time(NULL);

	while (time(NULL) < (start + 10))
		nb_loops ++;

	return (void *) nb_loops;
}

#define NB_THREADS  5

int main(void)
{
	int i;
	void * result;
	long nice_value[NB_THREADS];
	pthread_t thread[NB_THREADS];
	long loops_count = 0;
	long nb_loops[NB_THREADS];

	for (i = 0; i < NB_THREADS; i ++)
		nice_value[i] = (i+1) * (20 / NB_THREADS);

	for (i = 0; i < NB_THREADS; i ++)
		pthread_create(& (thread[i]), NULL, thread_function,
		               (void *) nice_value[i]);
	for (i = 0; i < NB_THREADS; i ++) {
		pthread_join(thread[i], & result);
		nb_loops[i] = (long) result;
		loops_count += nb_loops[i];
	}
	for (i = 0; i < NB_THREADS; i ++)
		printf("[%ld] %ld (%.0f)\n", nice_value[i],
		       nb_loops[i],
		       100.0 * nb_loops[i] / loops_count);
	return EXIT_SUCCESS;
}
