// ---------------------------------------------------------------------
// exemple-reponse-irq-serie.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2015 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <fcntl.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>

volatile int quit = 0;

void handler_sigint(int unused)
{
	quit = 1;
}

int main(int argc, char * argv[])
{
	int fd;
	unsigned char  byte;
	struct termios params;
	struct termios origin;

	if (argc != 2) {
		fprintf(stderr, "usage: %s port_serie\n",argv[0]);
		exit(EXIT_FAILURE);
	}

	signal(SIGINT, handler_sigint);

	if ((fd = open(argv[1], O_RDWR | O_NONBLOCK))<0){
		perror(argv[1]);
		exit(EXIT_FAILURE);
	}

	tcgetattr(fd, &origin);
	tcgetattr(fd, &params);
	cfmakeraw(&params);
	cfsetispeed(&params, B115200);
	cfsetospeed(&params, B115200);
	params.c_iflag |= IGNPAR;
	params.c_cflag &= ~(CSIZE | PARENB | CSTOPB);
	params.c_cflag |= CS8 | CLOCAL;
	if (tcsetattr(fd, TCSANOW, & params) != 0) {
		perror("tcsetattr");
		exit(EXIT_FAILURE);
	}
	params.c_cc[VMIN]  = 1;
	params.c_cc[VTIME] = 0;
	fcntl(fd, F_SETFL, fcntl(fd, F_GETFL) & ~O_NONBLOCK);

	while (! quit) {
		if (read(fd, &byte, 1) < 0) {
			perror(argv[1]);
			exit(EXIT_FAILURE);
		}
		if (byte != 'A')
			continue;
		if (write(fd, &byte, 1) < 0) {
			perror(argv[1]);
			exit(EXIT_FAILURE);
		}
		tcdrain(fd);
		while (byte != '\n') {
			read(fd, &byte, 1);
			write(STDOUT_FILENO, &byte, 1);
		}
	}
	tcsetattr(fd, TCSANOW, &origin);
	close(fd);
	fprintf(stderr, "Bye !\n");
	return EXIT_SUCCESS;
}

