// ---------------------------------------------------------------------
// exemple-prise-mutex-06.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2015 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <pthread.h>
#include <sched.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>

static pthread_mutex_t  mutex = PTHREAD_MUTEX_INITIALIZER;
static int last = 0;

void * thread_function (void * arg)
{
	long number = (long) arg;
	struct sched_param param;
	struct timeval tv;

	param.sched_priority = 10;
	if (pthread_setschedparam(pthread_self(), SCHED_RR, & param) != 0) {
		perror("setschedparam");
		exit(EXIT_FAILURE);
	}

	while (1) {
		pthread_mutex_lock(& mutex);
		if (last != number) {
			gettimeofday(& tv, NULL);
			fprintf(stderr, "%ld.%06ld : %ld tient le mutex\n", tv.tv_sec, tv.tv_usec, number);
			last = number;
		}
		pthread_mutex_unlock(& mutex);
	}

	return NULL;
}


#define NB_THREADS 5
int main(void)
{
	long i;
	pthread_t thread[NB_THREADS];

	pthread_mutex_lock(& mutex);
	for (i = 0; i < NB_THREADS; i ++) {
		pthread_create(& thread[i], NULL, thread_function, (void *) (i+1));
		usleep(10000);
	}
	sleep(1);
	alarm(15);
	fprintf(stderr, "Liberation initiale du mutex\n");
	pthread_mutex_unlock(& mutex);
	for (i = 0; i < NB_THREADS; i ++)
		pthread_join(thread[i], NULL);
	return EXIT_SUCCESS;
}

