// ---------------------------------------------------------------------
// exemple-threads-rr-01.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2015 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <pthread.h>
#include <sched.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

void * thread_function(void *);

#define NB_THREADS  5

int main(void)
{
	long i;
	int err;
	pthread_attr_t attr;
	struct sched_param param;
	pthread_t thr[NB_THREADS];

	param.sched_priority = 80;
	pthread_attr_init (& attr);
	if ((err = pthread_attr_setschedpolicy(& attr, SCHED_RR)) != 0) {
		fprintf(stderr, "setschedpolicy: %s\n", strerror(err));
		exit(EXIT_FAILURE);
	}
	if ((err = pthread_attr_setschedparam(& attr, & param)) != 0) {
		fprintf(stderr, "setschedparam: %s\n", strerror(err));
		exit(EXIT_FAILURE);
	}
	if ((err = pthread_attr_setinheritsched(& attr, PTHREAD_EXPLICIT_SCHED)) != 0) {
		fprintf(stderr, "setinheritsched: %s\n", strerror(err));
		exit(EXIT_FAILURE);
	}
	for (i = 0; i < NB_THREADS; i ++) {
		if ((err = pthread_create(& (thr[i]), & attr, thread_function, (void *) i)) != 0) {
			fprintf(stderr, "pthread_create: %s\n", strerror(err));
			exit(EXIT_FAILURE);
		}
	}
	for (i = 0; i < NB_THREADS; i ++)
		pthread_join(thr[i], NULL);

	return EXIT_SUCCESS;
}


void * thread_function(void * arg)
{
	long number = (long) arg;
	int i, j;
	time_t start, stop;
	time(& start);
	for (i = 0; i < 100000; i ++)
		for (j = 0; j < 10000; j ++)
			;
	time(& stop);
	printf("[%ld] %ld -> %ld\n",
	        number, start, stop);
	return NULL;
}

