// ---------------------------------------------------------------------
// exemple-interruption-01.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2015 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>


int main(int argc, char * argv[])
{
	long int threshold;
	struct timeval start;
	struct timeval now;
	struct timeval previous = {0, 0};

	long long int duration;

	if ((argc != 2) || (sscanf(argv[1], "%ld", &threshold) != 1)) {
		fprintf(stderr, "usage: %s threshold-microsecond\n", argv[0]);
		exit(EXIT_FAILURE);
	}

	gettimeofday(& start, NULL);
	previous = start;
	while(1) {
		gettimeofday(& now, NULL);
		duration  = now.tv_sec - previous.tv_sec;
		duration *= 1000000;
		duration += now.tv_usec - previous.tv_usec;
		previous = now;
		if (duration >= threshold)
			fprintf(stderr, "%lld\n", duration);
		// Pause toutes les cinq secondes
		if (now.tv_sec - start.tv_sec > 5) {
			usleep(100000);
			gettimeofday(&start, NULL);
			previous = start;
		}
	}
	return EXIT_SUCCESS;
}

