// ---------------------------------------------------------------------
// exemple-alarme-01.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2015 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#include <alchemy/alarm.h>
#include <alchemy/task.h>
#include <alchemy/timer.h>

static RT_ALARM my_alarm;

void alarm_function (void * arg)
{
	int err;
	rt_printf("Time: %llu\n", rt_timer_read());
}


int main(void)
{
	int err;

	mlockall(MCL_CURRENT|MCL_FUTURE);

	err = rt_alarm_create(&my_alarm, "my-alarm",
	                      alarm_function, NULL);
	if (err != 0) {
		fprintf(stderr, "rt_alarm_create(): %s\n",
		                strerror(-err));
		exit(EXIT_FAILURE);
	}

	err = rt_alarm_start(&my_alarm, TM_NOW, 1000000000);
	if (err != 0) {
		fprintf(stderr, "rt_alarm_start: %s\n", strerror(-err));
		exit(EXIT_FAILURE);
	}

	for(;;)
		pause();

	return 0;
}

