// ---------------------------------------------------------------------
// exemple-hello-01.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2015 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#include <alchemy/task.h>

void say_hello_world (void * unused)
{
	while (1) {
		rt_printf("Hello from Xenomai Realtime Space\n");
		rt_task_sleep(1000000000LL); // 1 milliard ns = 1 s.
	}
}


int main(void)
{
	int err;
	RT_TASK task;

	mlockall(MCL_CURRENT|MCL_FUTURE);

	if ((err = rt_task_spawn(& task, "Hello_01",
	                         0, 50, T_JOINABLE,
	                         say_hello_world, NULL)) != 0) {
		fprintf(stderr, "rt_task_spawn: %s\n", strerror(-err));
		exit(EXIT_FAILURE);
	}
	rt_task_join(& task);
	return 0;
}

