// ---------------------------------------------------------------------
// exemple-periodique-01.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2015 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#include <alchemy/task.h>
#include <alchemy/timer.h>

void periodic_function (void * arg)
{
	int err;
	unsigned long overruns;

	rt_task_set_periodic(rt_task_self(), TM_NOW,  1000000000);
	rt_printf("[%lld] Timer set...\n", rt_timer_read());
	while (1) {
		overruns = 0;
		err = rt_task_wait_period(&overruns);
		if ((err != 0) && (err != -ETIMEDOUT))
			break;
		rt_printf("[%lld]", rt_timer_read());
		if (overruns != 0)
			rt_printf(" Overruns : %lu", overruns);
		rt_printf("\n");
	}
	fprintf(stderr, "rt_task_wait_period(): %s\n",
				strerror(-err));
	exit(EXIT_FAILURE);
}



int main()
{
	RT_TASK task;

	mlockall(MCL_CURRENT|MCL_FUTURE);

	if (rt_task_spawn(& task, NULL, 0, 50,
	        T_JOINABLE, periodic_function, NULL) != 0) {
		fprintf(stderr, "Unable to create the task\n");
		exit(EXIT_FAILURE);
	}

	rt_task_join(& task);
	return 0;
}


