// ---------------------------------------------------------------------
// exemple-periodique-04.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2015 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#include <alchemy/task.h>
#include <alchemy/timer.h>



void periodic_function (void * arg)
{
	RTIME previous = 0;
	RTIME now;
	RTIME period;
	RTIME duration;

	period = * (RTIME *) arg;
	period = period * 1000; // en ns
	rt_task_set_periodic(NULL, TM_NOW, period);

	while (1) {
		rt_task_wait_period(NULL);
		now = rt_timer_read();
		if (previous != 0) {
			duration = now - previous;
			rt_printf("%llu\n", duration/1000);
		}
		previous = now;
	}
}



int main(int argc, char * argv[])
{
	RT_TASK task;
	RTIME period;
	int err;

	mlockall(MCL_CURRENT|MCL_FUTURE);

	if ((argc != 2) || (sscanf(argv[1], "%llu", & period) != 1)) {
		fprintf(stderr, "usage: %s period_us\n", argv[0]);
		exit(EXIT_FAILURE);
	}

	if ((err = rt_task_spawn(& task, NULL, 0, 50,
	        T_JOINABLE, periodic_function, &period)) != 0) {
		fprintf(stderr, "rt_task_spaw: %s\n", strerror(-err));
		exit(EXIT_FAILURE);
	}

	rt_task_join(& task);
	return 0;
}


