// ---------------------------------------------------------------------
// exemple-hello-03.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2015 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#include <alchemy/task.h>


void hello_world_function (void * unused)
{
	int i;

	for (i = 5; i > 0; i --) {
		rt_fprintf(stderr, "Calling fprintf() in %d s.\n", i);
		rt_task_sleep(1000000000LL);
	}
	rt_fprintf(stderr, "Calling fprintf() now.\n");
	
	fprintf(stdout, "Hello World!\n");

	for (;;) {
		rt_fprintf(stderr, "fprintf() was called.\n");
		rt_task_sleep(1000000000LL);
	}
}


int main(void)
{
	int err;
	RT_TASK task;

	mlockall(MCL_CURRENT|MCL_FUTURE);

	if ((err = rt_task_spawn(& task, "Sigdebug 01",
	                         0, 50, T_JOINABLE | T_WARNSW,
	                         hello_world_function, NULL)) != 0) {
		fprintf(stderr, "rt_task_spawn: %s\n", strerror(-err));
		exit(EXIT_FAILURE);
	}
	rt_task_join(& task);
	return 0;
}

