// ---------------------------------------------------------------------
// exemple-watchdog-01.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2015 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#include <alchemy/task.h>
#include <alchemy/timer.h>


int main(void)
{
	int err;
	RT_TASK task;
	int nb_seconds;
	int i;

	mlockall(MCL_CURRENT|MCL_FUTURE);

	if ((err = rt_task_shadow(& task, "Watchdog-Test",
	                         99, 0)) != 0) {
		fprintf(stderr, "rt_task_shadow: %s\n", strerror(-err));
		exit(EXIT_FAILURE);
	}
	nb_seconds = 1;
	while (1) {
		rt_fprintf(stderr, "Active loop for %d s.\n", nb_seconds);
		rt_task_sleep(500000000); // 0.5 s
		for (i = 0; i < nb_seconds; i ++)
			rt_timer_spin(1000000000ULL);
		nb_seconds ++;
	}
	return 0;
}

