// ---------------------------------------------------------------------
// exemple-user-rtdm-read.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2018 - Christophe BLAESS
// https://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#define BUFFER_SIZE 128

int main (int argc, char * argv[])
{
	int fd;
	int i;
	char buffer[BUFFER_SIZE];

	if (argc < 2) {
		fprintf(stderr, "usage: %s rtdm-device\n", argv[0]);
		exit(EXIT_FAILURE);
	}

	fd = open(argv[1], O_RDONLY);
	if (fd < 0) {
		fprintf(stderr, "%s: opening %s failed with error: %s\n",
		                argv[0], argv[1], strerror(-fd));
		exit(EXIT_FAILURE);
	}

	while ((i = read(fd, buffer, BUFFER_SIZE - 1)) > 0) {
		buffer[i] ='\0';
		printf("%s\n", buffer);
	}

	close(fd);
	return EXIT_SUCCESS;
}
