// ---------------------------------------------------------------------
// exemple-user-rtdm-write.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012-2018 - Christophe BLAESS
// https://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>


int main (int argc, char * argv[])
{
	int err;
	int fd;
	int i;

	if (argc < 2) {
		fprintf(stderr, "usage: %s rtdm-device message...\n", argv[0]);
		exit(EXIT_FAILURE);
	}

	fd = open(argv[1], O_WRONLY);
	if (fd < 0) {
		fprintf(stderr, "%s: opening %s failed with error: %s\n",
		                argv[0], argv[1], strerror(-fd));
		exit(EXIT_FAILURE);
	}

	for (i = 2; i < argc; i ++) {
		err = write(fd, argv[i], strlen(argv[i]));
		if (err < 0) {
			fprintf(stderr, "%s: write into %s failed with error: %s\n",
			                argv[0], argv[1], strerror(-err));
			exit(EXIT_FAILURE);
		}
	}

	close(fd);
	exit(EXIT_SUCCESS);
}
